<?php
namespace Financeiro\Logic\ContasPagar\ImportacaoRateio;

class ExcelUtils 
{
	private $xls;
	private $columnMaxBound;
	private $rowMaxBound;

	public function __construct($xlsFilePath) 
	{
        $xls       = \PHPExcel_IOFactory::createReaderForFile($xlsFilePath);

		$xlsReader = $xls->load($xlsFilePath);
		$this->xls = $xlsReader->getActiveSheet();

		$this->columnMaxBound = \PHPExcel_Cell::columnIndexFromString($this->xls->getHighestColumn());
		$this->rowMaxBound    = $this->xls->getHighestRow();
	}

    /*
     * Phillipe Silva - 07/11/14
     * Adicionado parâmetro opcional para leituras de XLS que não seja considerado o primeiro registro como cabeçalho.
     */
	public function buildDataIntoJson()
	{
		return $this->getData();
	}

	private function getData()
	{
		$headers = $this->getHeaders();
		$data    = array();
        // A primeira linha a ser percorrida deve ser a primeira contendo dados (a linha 1 contem os cabecalhos dos dados).
        for ($i = 1; $i <= $this->rowMaxBound; $i++) {
            foreach ($headers as $key => $value) {
                $cell = $this->xls->getCellByColumnAndRow($key, $i);
                $data[$i][$value] = $cell->getFormattedValue();
            }
        }

		return $data;
	}

	private function getHeaders() 
	{
		$headers = array();
		for ($i = 0; $i < $this->columnMaxBound; $i++) {
			$cell = $this->xls->getCellByColumnAndRow($i, 1);
			$headers[] = strtoupper(Util::removeCaracteresInvalidos($cell->getValue()));
		}

		return $headers;
	}

}